import "android.content.Context"
import "java.io.File"
import "android.widget.ArrayAdapter"
import "android.app.AlertDialog" -- إذا لم تكن LuaDialog معرفة في بيئتك

-- المسارات
local basePath = "/storage/emulated/0/解说/Notes"
local currentPath = basePath
local pickedPath = nil
local savedPath = nil  -- المتغير لحفظ المسار

-- قراءة القيمة المخزنة في SharedPreferences
 local prefs = activity.getSharedPreferences(pathes", Context.MODE_PRIVATE)
savedPath = prefs.getString("selectedPath", basePath)  -- إذا لم يكن موجودًا، يستخدم basePath

-- الدالة المسؤولة عن عرض واجهة اختيار المجلد
function showFolderPicker()
  function listFolders(path)
    local folders = {}
    local dir = File(path)
    if dir.isDirectory() then
      local files = dir.listFiles()
      if files then
        for i = 0, #files - 1 do
          local file = files[i]
          if file.isDirectory() then
            table.insert(folders, file.getName())
          end
        end
      end
    end
    return folders
  end

  function updateList(path)
    currentPath = path
    local items = listFolders(path)
    adapter.clear()
    for _, folder in ipairs(items) do
      adapter.add(folder)
    end
    adapter.notifyDataSetChanged()
  end

  layout = {
    LinearLayout;
    orientation = "vertical";
    layout_width = "match_parent";
    layout_height = "match_parent";
    {
      Button;
      id = "backButton";
      text = T.previous;
      layout_width = "wrap_content";
      layout_height = "wrap_content";
    };
    {
      ListView;
      id = "listView";
      layout_width = "match_parent";
      layout_height = "0dp";
      layout_weight = 1;
    };
    {
      LinearLayout;
      orientation = "horizontal";
      layout_width = "match_parent";
      layout_height = "wrap_content";
      gravity = "end";
      {
        Button;
        id = "okButton";
        text = T.okay;
      };
    };
  }

  adapter = ArrayAdapter(activity, android.R.layout.simple_list_item_1, {})

  dlg = LuaDialog()
  dlg.setTitle("")
  dlg.setView(loadlayout(layout))
  listView.setAdapter(adapter)

  listView.onItemClick = function(l, v, pos, id)
    local selectedFolder = adapter.getItem(pos)
    local newPath = currentPath .. "/" .. selectedFolder
    updateList(newPath)
  end

  backButton.onClick = function()
    local parent = File(currentPath).getParent()
    if parent and parent:find(basePath) == 1 then
      updateList(parent)
    end
  end

  okButton.onClick = function()
    pickedPath = currentPath
    if pickedPath ~= savedPath then
      savedPath = pickedPath
      local editor = prefs.edit()
      editor.putString("selectedPath", savedPath)
      editor.apply()
    end

    service.speak("سيتم حفظ الملاحظات التي تخزنها في المسار " .. savedPath .. ". يمكنك تغيير ذلك لاحقا حين إنشاء ملاحظة جديدة.")
    print("سيتم حفظ الملاحظات التي تخزنها في المسار " .. savedPath .. ". يمكنك تغيير ذلك لاحقًا حين إنشاء ملاحظة جديدة.")
    dlg.dismiss()
  end

  -- التهيئة الأولى حسب المسار المخزن
  updateList(savedPath)

  dlg.show()

  print(T.ItemsPickerTitle)
end
