local systemLang = Locale.getDefault().getLanguage()
local sharedPrefs = activity.getSharedPreferences("settings", Context.MODE_PRIVATE)
local languagePref = sharedPrefs.getString("language", nil)
local lang = languagePref or systemLang or "en"

package.path = package.path .. ";/storage/emulated/0/?.lua"
local translations = require("files.Libraries.strings")
T = translations[lang] or translations[systemLang] or translations["en"]
selectedLanguage = lang

local handler = Handler()
local function reloadTranslations()
  package.loaded["files.Libraries.strings"] = nil
  translations = require("files.Libraries.strings")
  T = translations[lang] or translations[systemLang] or translations["en"]
  handler.postDelayed(reloadTranslations, 1000)
end

handler.post(reloadTranslations)
