require "import"
import "java.io.File"
import "android.widget.*"
import "android.view.*"
import "com.androlua.LuaDialog"

basePath = "/storage/emulated/0/解说/Notes/"
currentPath = basePath
noteFiles = {}
folderNames = {}
folders = {}

function getFolders(path)
  local folders = {}
  local folder = File(path)
  if folder.exists() then
    local list = folder.listFiles()
    if list ~= nil then
      for i = 1, #list do
        local f = list[i - 1]
        if f.isDirectory() then
          table.insert(folders, f.getName())
        end
      end
    end
  end
  return folders
end

function getNotes(path)
  local notes = {}
  local files = {}
  local folder = File(path)
  if folder.exists() then
    local list = folder.listFiles()
    if list ~= nil then
      for i = 1, #list do
        local f = list[i - 1]
        if f.isFile() and (f.getName():lower():match("%.txt$") or f.getName():lower():match("%.note$")) then
          local name = f.getName()
          local nameWithoutExtension = name:gsub("%.txt$", ""):gsub("%.note$", "")
          table.insert(notes, nameWithoutExtension)
          table.insert(files, f.getAbsolutePath())
        end
      end
    end
  end
  return notes, files
end

function updateFolderList(path)
  folders = getFolders(path)
  folderNames = {T.back}
  table.sort(folders)
  for i, folder in ipairs(folders) do
    table.insert(folderNames, folder)
  end
  adapter.clear()
  for i = 1, #folderNames do
    adapter.add(folderNames[i])
  end
  adapter.notifyDataSetChanged()
end

function browseFolders(startPath)
  currentPath = startPath
  folders = getFolders(startPath)
  folderNames = {T.back}
  table.sort(folders)
  for i, folder in ipairs(folders) do
    table.insert(folderNames, folder)
  end

  layout = {
    LinearLayout;
    orientation = "vertical";
    layout_width = "match_parent";
    layout_height = "wrap_content";
    backgroundColor = "#000000";
    {
      ListView;
      id = "folderList";
      layout_width = "match_parent";
      layout_height = "wrap_content";
    };
    {
      Button;
      id = "okButton";
      text = T.okay;
      layout_width = "match_parent";
      layout_height = "wrap_content";
    };
  }

  adapter = ArrayAdapter(activity, android.R.layout.simple_list_item_1, folderNames)

  dlg = LuaDialog()
  dlg.setTitle(T.pick_menu_title)
  dlg.setView(loadlayout(layout))
  dlg.setCanceledOnTouchOutside(false)
  dlg.setCancelable(true)
  dlg.show()

  folderList.setAdapter(adapter)

  folderList.setOnItemClickListener(AdapterView.OnItemClickListener {
    onItemClick = function(parent, view, position, id)
      if position == 0 then
        if currentPath ~= basePath then
          currentPath = File(currentPath).getParent() .. "/"
          updateFolderList(currentPath)
        end
      else
        local selectedFolder = folders[position]
        currentPath = currentPath .. selectedFolder .. "/"
        updateFolderList(currentPath)
      end
    end
  })

  okButton.setOnClickListener(View.OnClickListener {
    onClick = function(v)
      dlg.dismiss()
      getNotes(currentPath) -- استخراج الملاحظات بصمت
    end
  })
end