import "java.io.File"
import "android.widget.ListView"
import "android.widget.TextView"
import "android.app.AlertDialog"
import "android.widget.LinearLayout"
import "android.widget.Button"
import "android.view.View"

local CipherModule = require("files.Libraries.Modules.MarcoCypher")

function showNoteContent(parent, view, position, id)
  local fp = noteFiles[position + 1]
  if not fp or fp:find("لا توجد ملاحظات") then return end

  local NoteContent = ""
  local f = io.open(fp, "r")
  if f then
    NoteContent = f:read("*a") or ""
    f:close()
  end

  local success, decrypted = pcall(function()
    return CipherModule.cipher(NoteContent, "decryptMarco")
  end)

  if not success then
    decrypted = T.decryptionError .. tostring(decrypted)
  end

  local content = {}
  for line in decrypted:gmatch("[^\r\n]+") do
    table.insert(content, {text = line})
  end

  if #content == 0 then
    table.insert(content, {text = T.emptyNoteToRead})
  end

  local listView = ListView(activity)
  listView.setBackgroundColor(0xFFFFFFFF)

  local item_layout = {
    TextView;
    id = "text";
    layout_width = "fill";
    layout_height = "wrap";
    padding = "16dp";
    textColor = 0xFF000000;
    textSize = "18sp";
    backgroundColor = 0xFFFFFFFF;
  }

  local adapter = LuaAdapter(activity, content, item_layout)
  listView.setAdapter(adapter)

  local layout = LinearLayout(activity)
  layout.setOrientation(1)
  layout.addView(listView)

  local dialogBuilder = AlertDialog.Builder(activity)
  dialogBuilder.setTitle(tostring(File(fp).getName():gsub("%.txt$", ""):gsub("%.note$", "")))
  dialogBuilder.setView(layout)
  dialogBuilder.setNegativeButton(T.close or "إغلاق", nil)
  dialogBuilder.setNeutralButton("More options", function(dialog)
    local popupLayout = LinearLayout(activity)
    popupLayout.setOrientation(1)
    popupLayout.setPadding(24, 24, 24, 24)

    local selectButton = Button(activity)
    selectButton.setText("select tts engine: jieshuo paid version is required.")
    selectButton.setOnClickListener(View.OnClickListener {
      onClick = function(v)
        if service.execute("Select TTS engine") then
          return true
        end
      end
    })

    popupLayout.addView(selectButton)

    local moreDialog = AlertDialog.Builder(activity)
      .setTitle("")
      .setView(popupLayout)
      .setNegativeButton(T.close or "إغلاق", function(d) d.dismiss() end)
      .create()

    moreDialog.show()
  end)

  dialogBuilder.show()
end